package agent.simple;

import agentspace.Context;
import agentspace.Agent;
import agentspace.Mobile;
import agentspace.Preservable;
import agentspace.event.AgentEvent;

public class Simple implements Agent, Mobile, Preservable {
	String state = "uninitialized"; 
	TestState t = null;
	public Simple() {
		t = new TestState();
		t.setMessage(" in ");
		System.out.println("Test: an instance created. ["+state+"]"+t.getMessage());
		state = "initalized";
	}
		
	/* 
	 * @see agentspace.SerialiableAgent#create(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void create(AgentEvent evt, Context context) {
		System.out.println("Test: method create() calling ["+state+"]"+t.getMessage());
		state = "created";
		System.out.println("Test: method create() called ["+state+"]");
	}
	/* 
	 * @see agentspace.SerialiableAgent#destroy(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void destroy(AgentEvent evt, Context context) {
		System.out.println("Test: method destroy() calling ["+state+"]"+t.getMessage());
		state = "destroying";
		System.out.println("Test: method destroy() called ["+state+"]");
	}
	/* 
	 * @see agentspace.SerialiableAgent#suspend(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void suspend(AgentEvent evt, Context context) {
		System.out.println("Test: method suspend() calling ["+state+"]"+t.getMessage());
		state = "suspending";
		System.out.println("Test: method suspend() called ["+state+"]");
	}
	/* 
	 * @see agentspace.SerialiableAgent#resume(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void resume(AgentEvent evt, Context context) {
		System.out.println("Test: method resume() calling ["+state+"]"+t.getMessage());
		state = "resumed";
		System.out.println("Test: method resume() called ["+state+"]");
	}
	/* 
	 * @see agentspace.MobileAgent#arrive(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void arrive(AgentEvent evt, Context context) {
		System.out.println("Test: method arrive() calling ["+state+"]"+t.getMessage());
		state = "arrived";
		System.out.println("Test: method arrive() called ["+state+"]");
	}
	/* 
	 * @see agentspace.MobileAgent#leave(agentspace.event.AgentEvent, agentspace.Context)
	 */
	public void leave(AgentEvent evt, Context context) {
		System.out.println("Test: method leave() calling ["+state+"]"+t.getMessage());
		state = "moving";
		System.out.println("Test: method leave() called ["+state+"]");
	}
}

class TestState implements java.io.Serializable {
	String msg;
	int counter = 0;
	TestState() {}
	public void setMessage(String msg) {
		this.msg = msg; 
	}
	public String getMessage() {
		counter = counter + 1;
		return msg + "("+counter+")";
	}
}
